unit Motif;

{Mik - do change as you wish, but don't delete my name and put your on it.
Credit on litletitle component.
19/02/98 removed Commandmenu as it cross draws.
16/01/98 remove OpenLook option because Delphi's button does not match.
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

const
  THRESHOLD = 20;
type
  TButtonArrow = (arwUp, arwDown, arwRestore);

type
  TMotifForm = class(TForm)
  private
    { Private declarations }
    fMenuUp : boolean;       {state of the system menu}
    TitleBarSize : integer;  {height of the title bar in pixels}
    function TestWinStyle(dwStyleBit : longint) : boolean;
    function HasCaption : boolean;
    function GetTitleBarRect(var rc : TRect) : boolean;
    function GetControlBoxRect(var rc : TRect) : boolean;
    function GetMinButtonRect(var rc : TRect) : boolean;
    function GetMaxButtonRect(var rc : TRect) : boolean;
    function GetButtonRect(nPos : word; var rc : TRect) : boolean;
    function DoMenu : boolean;
    procedure SetupSystemMenu(menu : HMenu);
    procedure DrawControlBox(dc : HDC; fInvert : boolean);
    function DepressMinMaxButton(HitTest : word; var rc : TRect) : boolean;
    procedure DrawButton(dc : HDC; fMin, fDepressed : boolean);
    function DrawCaption : boolean;
    Procedure drawframe;
{    Procedure Drawcaptionpush(pushed:boolean);}
  protected
    fActive, fSysMenu, fMin, fMax : BOOLEAN;
    Pushed : boolean;
    FRAMEWIDTH : integer;
    corner : integer;
    constructor create(owner: tcomponent); override;
    procedure paint; override;
    procedure resize; override;
    procedure WndProc(var Message : TMessage); override;
    procedure WMNCCreate(var Message : TWMNCCreate); message WM_NCCREATE;
    procedure WMNCCalcSize(var Message : TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCHitTest(var Message : TWMNCHitTest); message WM_NCHITTEST;
    procedure WMNCLButtonDblClk(var Message : TWMNCLButtonDblClk); message WM_NCLBUTTONDBLCLK;
    procedure WMNCLButtonDown(var Message : TWMNCLButtonDown); message WM_NCLBUTTONDOWN;
    procedure WMSysChar(var Message : TWMSysChar); message WM_SYSCHAR;
    procedure WMCommand(var Message : TMessage); message WM_COMMAND;
    procedure WMKeyDown(var Message : TWMKeyDown); message WM_KEYDOWN;
    procedure WMKeyUp(var Message : TWMKeyUp); message WM_KEYUP;
    procedure WMSysKeyDown(var Message : TWMSysKeyDown); message WM_SYSKEYDOWN;
    procedure WMSysKeyUp(var Message : TWMSysKeyUp); message WM_SYSKEYUP;
    procedure WMGetMinMaxInfo(var Message : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
  public
    { Public declarations }
  end;

var
  MotifForm: TMotifForm;

implementation

{$R *.DFM}


function TMotifForm.TestWinStyle(dwStyleBit : longint) : boolean;
begin
  Result :=  ((GetWindowLong(Handle, GWL_STYLE) and dwStyleBit) <> 0);
end;

function TMotifForm.HasCaption : boolean;
begin
  Result := borderstyle <> bsnone;
end;

function TMotifForm.GetTitleBarRect(var rc : TRect) : boolean;
begin
  Result := false;  {Initially assume no caption.}
  if HasCaption then begin
    GetWindowRect(Handle, rc);
    if TestWinStyle(WS_THICKFRAME) then  {Adjust for borders.}
      InflateRect(rc, -GetSystemMetrics(SM_CXFRAME),
                      -GetSystemMetrics(SM_CYFRAME))
    else if TestWinStyle(DS_MODALFRAME) then
      InflateRect(rc, -(GetSystemMetrics(SM_CXDLGFRAME)
                      + GetSystemMetrics(SM_CXBORDER)),
                      -(GetSystemMetrics(SM_CYDLGFRAME)
                      + GetSystemMetrics(SM_CYBORDER)))
    else if TestWinStyle(WS_BORDER) then
      InflateRect(rc, -GetSystemMetrics(SM_CXBORDER),
                      -GetSystemMetrics(SM_CYBORDER));
    rc.bottom := rc.top + TitleBarSize;
    Result := true;
  end else
    SetRectEmpty(rc);
end;

function TMotifForm.GetControlBoxRect(var rc : TRect) : boolean;
begin
  Result := false;  {Initially assume no control box.}
  if GetTitleBarRect(rc) then begin
    if TestWinStyle(WS_SYSMENU) then begin
      rc.right := rc.left + TitleBarSize - 1;
      Dec(rc.bottom);
      Result := true;
    end else
      SetRectEmpty(rc);
  end;
end;

function TMotifForm.GetMinButtonRect(var rc : TRect) : boolean;
begin
  Result := false;  {Initially assume no min. button.}
  if TestWinStyle(WS_MINIMIZEBOX) then begin
    if TestWinStyle(WS_MAXIMIZEBOX) then  {If win has a maximize box,}
      Result := GetButtonRect(2, rc)      {min. box is in position 2.}
    else                                  {Otherwise,                }
      Result := GetButtonRect(1, rc);     {min. box is in position 1.}
  end else
    SetRectEmpty(rc);
end;

function TMotifForm.GetMaxButtonRect(var rc : TRect) : boolean;
begin
  Result := false;  {Initially assume no max. button.}
  if TestWinStyle(WS_MAXIMIZEBOX) then
    Result := GetButtonRect(1, rc)
  else
    SetRectEmpty(rc);
end;

function TMotifForm.GetButtonRect(nPos : word; var rc : TRect) : boolean;
begin
  Result := false;  {Initially assume no button.}
  if GetTitleBarRect(rc) then begin
    Dec(rc.right, TitleBarSize * (nPos - 1) + 1);
    rc.left := rc.right - TitleBarSize + 2;
    Result := true;
  end;
end;

function TMotifForm.DoMenu : boolean;
var
  dc   : HDC;
  rc   : TRect;
  pt   : TPoint;
  menu : HMenu;
begin
  Result := false;  {Initially assume no menu}
  if TestWinStyle(WS_SYSMENU) then begin
    dc := GetWindowDC(Handle);
    if dc <> 0 then begin
      {Invert the control box}
      DrawControlBox(dc, true);
      {Pop up the mock-system menu}
      pt := Point(0, -1);
      GetWindowRect(Handle, rc);
      {Convert coordinates to screen coords. using functions in WinProcs unit}
      {("WinProcs" must be given to avoid calling TForm1's ClientToScreen() )}
      WinProcs.ClientToScreen(Handle, pt);
      WinProcs.ClientToScreen(Handle, rc.BottomRight);
      menu := GetSystemMenu(Handle, false);
      SetupSystemMenu(menu);
      TrackPopupMenu(menu, 0, pt.x, pt.y, 0, Handle, @rc);
      DrawControlBox(dc, false);
      ReleaseDC(Handle, dc);
    end;
    Result := true;
  end;
end;

procedure TMotifForm.SetupSystemMenu(menu : HMenu);
var
  wMove    : word;
  wSize    : word;
  wMinBox  : word;
  wMaxBox  : word;
  wRestore : word;
begin
  {Initially assume all menu items should be grayed}
  wMove    := MF_GRAYED;
  wSize    := MF_GRAYED;
  wMinBox  := MF_GRAYED;
  wMaxBox  := MF_GRAYED;
  wRestore := MF_GRAYED;
  {Now check the window styles, etc.}
  if not (IsIconic(Handle) or IsZoomed(Handle)) then begin
    if TestWinStyle(WS_CAPTION) then
      wMove := MF_ENABLED;
    if TestWinStyle(WS_THICKFRAME) then
      wSize := MF_ENABLED;
  end;
  if TestWinStyle(WS_MINIMIZEBOX) then
    wMinBox := MF_ENABLED;
  if TestWinStyle(WS_MAXIMIZEBOX) or IsIconic(Handle) then
    wMaxBox := MF_ENABLED;
  if IsZoomed(Handle) then
    wRestore := MF_ENABLED;
  EnableMenuItem(menu, SC_MOVE,     wMove);
  EnableMenuItem(menu, SC_SIZE,     wSize);
  EnableMenuItem(menu, SC_MINIMIZE, wMinBox);
  EnableMenuItem(menu, SC_MAXIMIZE, wMaxBox);
  EnableMenuItem(menu, SC_RESTORE,  wRestore);
end;

procedure TMotifForm.DrawControlBox(dc : HDC; fInvert : boolean);
var
  rc    : TRect;
  rcBox : TRect;
begin
  {Prepare to draw the control box}
  if dc <> 0 then begin
    {Calculate size and position of control box in window coords.}
    GetControlBoxRect(rcBox);
    GetWindowRect(Handle, rc);
    OffsetRect(rcBox, -rc.left, -rc.top);
    {Calculate separator line to right of control box}
    rc := rcBox;
    rc.left := rc.right;
    inflaterect(rc,-1,-1);
    inflaterect(rcbox,-1,-1);
{    Inc(rc.left);
    inc(rcBox.left);}
    {Fill control box area}
    if factive then
      SetBkColor(dc, ColorToRGB(clActiveBorder))
    else
      SetBkColor(dc, ColorToRGB(clInActiveBorder));
    ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rcBox, nil, 0, nil);
    {Draw separator line}
    SetBkColor(dc, ColorToRGB(clbtnshadow));
    ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);

    {If title bar isn't too small, draw the lil' horizontal doo-hickey}
    if TitleBarSize > 4 then begin
      rc := rcBox;
      rc.top    := rcBox.top + ((TitleBarSize - 1) div 2);
      rc.bottom := rc.top + 3;
      rc.left   := rc.left + 4;
      rc.right  := rc.right - 3;
      SetBKColor(dc, ColorToRGB(clGray));
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      OffsetRect(rc, -1, -1);
      SetBkColor(dc, ColorToRGB(clBlack));
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      InflateRect(rc, -1, -1);
      SetBkColor(dc, ColorToRGB(clWhite));
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);

      SetBkColor(dc, ColorToRGB(clBtnHighlight));
      {Left edge}
      rc := rcBox;
      rc.right := rc.left + 1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Top edge}
      rc := rcBox;
      rc.bottom := rc.top + 1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Draw button shadow (right & bottom)}
      SetBkColor(dc, ColorToRGB(clBtnShadow));
      {Right edge}
      rc := rcBox;
      rc.left := rc.right - 1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {bottom edge}
      rc := rcBox;
      rc.top := rc.bottom  - 1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
    end;
  end;
  {Invert the control box if needed}
  if fInvert then
  begin
{    InvertRect(dc, rcBox);}
      {Draw depressed state}
      SetBkColor(dc, ColorToRGB(clActiveBorder));
      {Left edge}
      rc := rcBox;
      rc.right := rc.left + 2;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Top edge}
      rc := rcBox;
      rc.bottom := rc.top + 2;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Adjust rcButton to everything inside the shadows/hilights}
      Inc(rcBox.left, 2 * 2);
      Inc(rcBox.top,  2 * 2);
  end;
end;

function TMotifForm.DepressMinMaxButton(HitTest : word; var rc : TRect) : boolean;
var
  msg        : TMsg;
  fDepressed : boolean;
  fDone      : boolean;
begin
  fDone := false;  {we've only just begun}
  fDepressed := true;  {initially draw button in down state}
  DrawButton(0, (HitTest = HTMINBUTTON), fDepressed);
  SetCapture(Handle);  {collect all mouse events until WM_LBUTTONUP}
  while not fDone do begin  {loop until the button is released}
    if PeekMessage(msg, 0, WM_MOUSEFIRST, WM_MOUSELAST, PM_REMOVE) then begin
      case msg.message of
      WM_LBUTTONUP:
        begin
          PUSHED := FALSE;
          if fDepressed then
            DrawButton(0, (HitTest = HTMINBUTTON), not fDepressed);
          ReleaseCapture;
          Result := PtInRect(rc, msg.pt);
          fDone  := true;
        end;
      WM_MOUSEMOVE:
        if PtInRect(rc, msg.pt) then begin
          if not fDepressed then begin
            fDepressed := true;
            DrawButton(0, (HitTest = HTMINBUTTON), fDepressed);
          end;
        end else begin
          if fDepressed then begin
            fDepressed := false;
            DrawButton(0, (HitTest = HTMINBUTTON), fDepressed);
          end;
        end;
      end;
    end;
  end;
end;

procedure TMotifForm.DrawButton(dc : HDC; fMin, fDepressed : boolean);

var
  rc          : TRect;
  rcButton    : TRect;
  fDC         : boolean;  {did we have to create the DC here?   }
  nOffset     : word;     {displacement by button shadow/hilight}
  n           : integer;
  mpen : hpen;
begin
   MPEN := CREATEPEN(PS_SOLID,1,ColorToRGB(clBtnHighlight));
    nOffset := 2;
  if dc = 0 then
  begin
   fDC := true;
   dc  := GetWindowDC(Handle);
  end else
    fDC := false;
  if dc <> 0 then begin
    {Get size & position of button, and convert to window coordinates}
    if fMin then
      GetMinButtonRect(rcButton)
    else
      GetMaxButtonRect(rcButton);
    GetWindowRect(Handle, rc);
    OffsetRect(rcButton, -rc.left, -rc.top);
    {Draw vertical separator line to the left of button}
    rc := rcButton;
    rc.right := rc.left;
    Dec(rc.left,2);
    Dec(rc.bottom);
    inflaterect(rc,-1,-1);
    inflaterect(rcButton,-1,-1);

    SetBkColor(dc, ColorToRGB(clWindowFrame));
    ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
    {Fill button area}
    if factive then
      SetBkColor(dc, ColorToRGB(clActiveBorder))
    else
      SetBkColor(dc, ColorToRGB(clInActiveBorder));
    ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rcButton, nil, 0, nil);
    if not fDepressed then begin
      {Draw button hilight (left & top)}
      SetBkColor(dc, ColorToRGB(clBtnHighlight));
      {Left edge}
      rc := rcButton;
      rc.right := rc.left + 1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Top edge}
      rc := rcButton;
      rc.bottom := rc.top + 1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Draw button shadow (right & bottom)}
      SetBkColor(dc, ColorToRGB(clBtnShadow));
      {Right edge}
      rc := rcButton;
      rc.left := rc.right +2;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      if TitleBarSize > THRESHOLD then begin
        Dec(rc.left);
        Inc(rc.top);
        ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      end;
      {Bottom edge}
      rc := rcButton;
      rc.top := rc.bottom  -1;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      if TitleBarSize > THRESHOLD then begin
        Dec(rc.top);
        Inc(rc.left);
        ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      end;
      {Adjust rcButton to everything inside the shadows/hilights}
      Inc(rcButton.left);
      Inc(rcButton.top);
      Dec(rcButton.right,  nOffset);
      Dec(rcButton.bottom, nOffset);
    end else begin
      nOffset := 1;
      {Draw depressed state}
      SetBkColor(dc, ColorToRGB(clActiveBorder));
      {Left edge}
      rc := rcButton;
      rc.right := rc.left + nOffset;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Top edge}
      rc := rcButton;
      rc.bottom := rc.top + nOffset;
      ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
      {Adjust rcButton to everything inside the shadows/hilights}
      Inc(rcButton.left, 1{2 * nOffset});
      Inc(rcButton.top,  1 {2 * nOffset});
    end;

    n := (GetSystemMetrics(SM_CYCAPTION) div 2)
         - (rcButton.right - rcButton.left);
    if n < 1 then
      InflateRect(rcButton, (n div 2) - 1, (n div 2) - 1);
    selectobject(dc,mpen);
if fMin then
    begin
    selectobject(dc,mpen);
    moveto(dc, rcButton.left + 3, rcButton.top + 3);
    lineto(dc, rcButton.left + 7, rcButton.top + 3);
    moveto(dc, rcButton.left + 3, rcButton.top + 3);
    lineto(dc, rcButton.left + 3, rcButton.top + 7);
    selectobject(dc,getstockobject(black_pen));
    moveto(dc, rcButton.left + 7, rcButton.top + 3);
    lineto(dc, rcButton.left + 7, rcButton.top + 7);
    lineto(dc, rcButton.left + 3, rcButton.top + 7);
    end
   else
    begin
    selectobject(dc,mpen);
    moveto(dc, rcButton.left + 2, rcButton.top + 1);
    lineto(dc, rcButton.left + 10, rcButton.top + 1);
    moveto(dc, rcButton.left + 2, rcButton.top + 1);
    lineto(dc, rcButton.left + 2, rcButton.top + 10);
    selectobject(dc,getstockobject(black_pen));
    moveto(dc, rcButton.left + 10, rcButton.top + 1);
    lineto(dc, rcButton.left + 10, rcButton.top + 10);
    lineto(dc, rcButton.left + 2, rcButton.top + 10);
    end;

    if fDC then
      ReleaseDC(Handle, dc);
  end;
   deleteobject(mpen);
end;

{Procedure TMotifForm.drawcaptionpush;
var Mpen : hpen;
  rc,rcCap     : TRect;
  dc : Hdc;
begin
 GetTitleBarRect(rcCap);
 GetWindowRect(Handle, rc);
 OffsetRect(rcCap, -rc.left, -rc.top);
 SetRect(rc, rcCap.left, rcCap.bottom  , rcCap.right, rcCap.bottom );

   if fSysMenu then
      Inc(rcCap.left, TitleBarSize -2);
    if fMax then
      Dec(rcCap.right, TitleBarSize);
    if fMin then
      Dec(rcCap.right, TitleBarSize);
 dc := GetWindowDC(Handle);
 MPEN := CREATEPEN(PS_SOLID,1,ColorToRGB(clBtnHighlight));
if NOT PUSHED then
    begin
    SelectObject(dc, mpen);
    moveto(dc, rcCap.left+2, rcCap.top);
    lineto(dc, rcCap.left+2,rcCap.bottom);
    moveto(dc, rcCap.left, rcCap.top +1);
    lineto(dc, rcCap.right,rcCap.top +1);
    end
    else
    begin
    SelectObject(dc, mpen);
    moveto(dc, rcCap.right-1, rcCap.top);
    lineto(dc, rcCap.right-1,rcCap.bottom);
    moveto(dc, rcCap.left, rcCap.bottom-1);
    lineto(dc, rcCap.right,rcCap.bottom -1);
    SelectObject(dc, GETSTOCKOBJECT(black_pen));
    moveto(dc, rcCap.left+2, rcCap.top);
    lineto(dc, rcCap.left+2,rcCap.bottom);
    moveto(dc, rcCap.left, rcCap.top +1);
    lineto(dc, rcCap.right,rcCap.top +1);
    end;
 deleteobject(MPEN);
 ReleaseDC(Handle, dc);
end;
}
function TMotifForm.DrawCaption: boolean;
var
  dc        : HDC;
  rc        : TRect;
  rcCap     : TRect;
  rgbText   : TColor;
  rgbBkGrnd : TColor;
  hbrCap    : HBrush;
  lpsz      : PChar;
  textlen   : word;
  lf        : TLogFont;
  font      : HFont;
  size      : TSize;
  cx, cy    : integer;
  Mpen : hpen;
begin
  dc := GetWindowDC(Handle);
  if dc <> 0 then begin
    {Determine colors}
    if fActive then begin
      rgbText   := ColorToRGB(clCaptionText);
      rgbBkGrnd := ColorToRGB(clActiveBorder);
    end else begin
      rgbText   := ColorToRGB(clInactiveCaptionText);
      rgbBkGrnd := ColorToRGB(clInactivebORDER);
    end;
  SelectObject(dc, GetStockObject(null_pen));
  hbrCap := CreateSolidBrush(ColorToRGB(color));
  hbrCap := SelectObject(dc, hbrCap);
    {Calculate titlebar rectangle in window coords.}
    GetTitleBarRect(rcCap);
    GetWindowRect(Handle, rc);
    OffsetRect(rcCap, -rc.left, -rc.top);
    {Calculate horizontal separator line below titlebar}

    SetRect(rc, rcCap.left, rcCap.top , rcCap.right , rcCap.bottom );
    hbrCap := CreateSolidBrush(rgbBkGrnd);
    hbrCap := SelectObject(dc, hbrCap);  {swap brushes with device context }
    Rectangle(dc, rcCap.left, rcCap.top, rcCap.right , rcCap.bottom);
    {Draw separator line}
    SetBkMode(dc, TRANSPARENT);
    SelectObject(dc, GetStockObject(NULL_BRUSH));
    SelectObject(dc, GetStockObject(NULL_PEN));
    SetBkColor(dc, rgbBkGrnd);
    ExtTextOut(dc, 0, 0, ETO_OPAQUE, @rc, nil, 0, nil);
    {Shrink caption area to avoid overlapping control box & min/max buttons}
    if fSysMenu then
      Inc(rcCap.left, TitleBarSize -2);
    if fMax then
      Dec(rcCap.right, TitleBarSize);
    if fMin then
      Dec(rcCap.right, TitleBarSize);
    inc(rcCap.right,1);
    dec(rcCap.bottom,1);
    {Draw caption background (don't use ExtTextOut, we may need dithered colors)}
    SelectObject(dc, GetStockObject(black_pen));
    Rectangle(dc, rcCap.left, rcCap.top, rcCap.right , rcCap.bottom);

   MPEN := CREATEPEN(PS_SOLID,1,ColorToRGB(clBtnHighlight));
    SelectObject(dc, mpen);
    moveto(dc, rcCap.left+2, rcCap.top);
    lineto(dc, rcCap.left+2,rcCap.bottom);
    moveto(dc, rcCap.left, rcCap.top +1);
    lineto(dc, rcCap.right,rcCap.top +1);

{    drawcaptionpush(false);}

    hbrCap := SelectObject(dc, hbrCap);  {swap brushes back again          }
    DeleteObject(hbrCap);                {delete the brush we created      }
    {Draw caption text here}
    textlen := GetWindowTextLength(Handle);     {Get length of caption text}
    lpsz := GlobalAllocPtr(GHND, textlen + 2);  {Allocate a text buffer    }
    if lpsz <> nil then begin
      GetWindowText(Handle, lpsz, textlen + 1); {Copy in caption text      }
      rgbText := SetTextColor(dc, rgbText);     {Swap text colors with dc  }
      {Prepare logical font structure to get a font to use.}
      FillChar(lf, sizeof(TLogFont), #0);       {Clear the font structure  }
      if screen.pixelsperinch > 96 then
       lf.lfHeight  := -(TitleBarSize - 10)
      else
       lf.lfHeight  := -(TitleBarSize - 6);
      lf.lfCharSet := ANSI_CHARSET;
      lf.lfQuality := DEFAULT_QUALITY;
      lf.lfClipPrecision := CLIP_LH_ANGLES or CLIP_STROKE_PRECIS;
      if TitleBarSize >= THRESHOLD then
        lf.lfWeight := FW_BOLD;
      {Use small fonts for caption since it looks more like "System" than Arial}
      lf.lfPitchAndFamily := FF_SWISS;
      font := CreateFontIndirect(lf);
      font := SelectObject(dc, font);        {swap font with device context}
      {Calculate centering for caption text}
      GetTextExtentPoint(dc, lpsz, textlen, size);
      cx := rcCap.left + ((rcCap.right - rcCap.left - size.cx) div 2);
      cy := rcCap.top + ((rcCap.bottom - rcCap.top - size.cy) div 2);
      if rcCap.left > cx then
        cx := rcCap.left;                  {limit starting position of text}
      {Draw caption text}
      ExtTextOut(dc, cx, cy, ETO_CLIPPED, @rcCap, lpsz, textlen, nil);
      font := SelectObject(dc, font);                 {swap font back again}
      DeleteObject(font);                             {delete it           }
      {Clean up device context & free memory}
      rgbText := SetTextColor(dc, rgbText);           {swap back text color}
      GlobalFreePtr(lpsz);                            {deallocate buffer   }
    end;
    {Draw control box, min button, and max button as needed}
    if fSysMenu then
      DrawControlBox(dc, false);
    if fMin then
      DrawButton(dc, true, false);
    if fMax then
      DrawButton(dc, false, false);
    Result := true;
    ReleaseDC(Handle, dc);
  end;
 DeleteObject(mpen);
end;

procedure tMotifForm.resize;
begin
inherited resize;
drawframe;
end;

procedure tMotifForm.PAINT;
BEGIN
inherited PAINT;
drawframe;
END;

procedure tMotifForm.drawframe;
var
  rec: trect;
  h : HDC;
  hbrCap    : HBrush;
  mpen : hpen;
  mcolor : longint;

Begin

  h := getwindowdc(handle);
  if factive then
    hbrCap := CreateSolidBrush(ColorToRGB(clActiveBorder))
  else
    hbrCap := CreateSolidBrush(ColorToRGB(clInActiveBorder));
  hbrCap := SelectObject(H, hbrCap);
 	Rectangle(h,0,0,width,framewidth);
 	Rectangle(h,0,0,framewidth,height);
 	Rectangle(h,width - framewidth,0,width,height);
 	Rectangle(h,0,height - framewidth,width,height);
  MPEN := CREATEPEN(PS_SOLID,1,ColorToRGB(clBtnHighlight));
	{**************************************************}
		{draw vertical lines on left side of form}
{    selectobject(h,getstockobject(BLACK_PEN));}
    selectobject(h,mpen);
		Moveto(h,0,0);
		Lineto(h,0,HEIGHT);
    selectobject(h,mpen);
		Moveto(H,1,0);                {column,row}
		Lineto(H,1,HEIGHT);
    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,0+FRAMEWIDTH,0);                {column,row}
		Lineto(H,0+FRAMEWIDTH,HEIGHT);

		{draw vertical line on WIDTH side of form}
    selectobject(h,mpen);
		Moveto(H,WIDTH-FRAMEWIDTH,0);
		Lineto(H,WIDTH-FRAMEWIDTH,HEIGHT);

    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,WIDTH-1,0);
		Lineto(H,WIDTH-1,HEIGHT);

		{draw horizontal line on 0 side of form}
		Moveto(H,0,0);
		Lineto(H,WIDTH,0);

    selectobject(h,Mpen);
		Moveto(H,0,0+1);
		Lineto(H,WIDTH,0+1);

{    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,FRAMEWIDTH,0+FRAMEWIDTH);
		Lineto(H,WIDTH,0+FRAMEWIDTH);}

		{draw horizontal line on HEIGHT side of form}
    selectobject(h,mpen);
		Moveto(H,FRAMEWIDTH,HEIGHT-FRAMEWIDTH);
		Lineto(H,WIDTH -FRAMEWIDTH ,HEIGHT-FRAMEWIDTH);

    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,0,HEIGHT);
		Lineto(H,WIDTH,HEIGHT);
    selectobject(h,MPEN);

	{****************************************************}
		{fill in "brass" areas for corners}
if Factive then
    mcolor :=ColorToRGB(clActiveBorder)
else
    mcolor :=ColorToRGB(clInActiveBorder);
    deleteobject(hbrCap);
    hbrCap := CreateSolidBrush(mcolor);
    hbrCap := SelectObject(H, hbrCap);
    deleteobject(mpen);
    MPEN := CREATEPEN(PS_SOLID,1,mcolor);
    selectobject(h,MPEN);
		{upper left}
		{fill in large areas}
		Rectangle(h,2,2,5,corner -1);
		Rectangle(h,2,2,corner -1,5);

	{------------------------}
		{lower left}
		{fill in large areas}
		Rectangle(h,2,HEIGHT,corner -1,HEIGHT-framewidth);
		Rectangle(h,2,HEIGHT-1,5,(HEIGHT- corner) -1);

	{-----------------------}
			{lower WIDTH}

			{fill in large areas}
		Rectangle(h,width-1,HEIGHT-1,WIDTH-corner -1,HEIGHT-4);
		Rectangle(h,width-1,HEIGHT-1,WIDTH-4,HEIGHT-corner -1);


		{-----------------------}
			{upper WIDTH}
			{fill in large areas}
		Rectangle(h,width-corner -1,2,WIDTH,5);
		Rectangle(h,width,corner -1,WIDTH-4,2);

    {-----draw the border btween corners and the bars}
    deleteobject(mpen);
    MPEN := CREATEPEN(PS_SOLID,1,ColorToRGB(clBtnHighlight));

    selectobject(h,getstockobject(BLACK_PEN));
		{upper left}
				{lower pixels}
		MoveTo(H,0,corner);
		LineTo(H,0+framewidth,corner);

				{upper pixels}
		MoveTo(H,corner,0);
		LineTo(H,corner,0+framewidth);
    selectobject(h,MPEN);

		{lower left}
     		{upper pixels}
    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,1,HEIGHT-corner -1);
		LineTo(H,framewidth,HEIGHT-corner -1);
    selectobject(h,MPEN);
		Moveto(H,1,HEIGHT-corner );
		LineTo(H,framewidth,HEIGHT-corner);

    selectobject(h,getstockobject(BLACK_PEN));
		MoveTo(H,corner,HEIGHT-framewidth);
		LineTo(H,corner,HEIGHT);
    selectobject(h,MPEN);
		MoveTo(H,corner +1,HEIGHT-framewidth);
		LineTo(H,corner +1 ,HEIGHT);

		{lower corner}
    {upper}
    selectobject(h,getstockobject(BLACK_PEN));
		MoveTo(H,WIDTH-corner -1,HEIGHT -framewidth);
		LineTo(H,WIDTH-corner -1,HEIGHT - 1);
    selectobject(h,MPEN);
		MoveTo(H,WIDTH-corner,HEIGHT -framewidth);
		LineTo(H,WIDTH-corner,HEIGHT- 1);
    {lower}
    selectobject(h,getstockobject(BLACK_PEN));
    MoveTo(H,WIDTH,HEIGHT-corner -1);
		LineTo(H,WIDTH-framewidth,HEIGHT-corner -1);
    selectobject(h,MPEN);
		MoveTo(H,WIDTH,HEIGHT-corner);
		LineTo(H,WIDTH-framewidth,HEIGHT-corner);

    {upper corner}
		{ lower }
    selectobject(h,MPEN);
		Moveto(H,WIDTH,corner +1);
		Lineto(h,WIDTH-framewidth,corner +1);
    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,WIDTH,corner );
		Lineto(h,WIDTH-framewidth,corner);
    {upper}
    selectobject(h,getstockobject(BLACK_PEN));
		Moveto(H,WIDTH-corner -1,1);
		Lineto(h,WIDTH-corner -1,framewidth);
    selectobject(h,MPEN);
		Moveto(H,WIDTH-corner,1);
		Lineto(h,WIDTH-corner,framewidth);

{***************** inner corner}
    selectobject(h,getstockobject(BLACK_PEN));

		{Upper Left}
		MoveTo(H,framewidth ,framewidth );
		LineTo(H,framewidth ,corner -1);
		Moveto(H,framewidth ,framewidth );
		LineTo(H,corner -1,framewidth );

		{Lower Left}
		MoveTo(H,framewidth ,HEIGHT-framewidth );
		LineTo(H,framewidth ,HEIGHT- corner -1 );    {draw vert}

    selectobject(h,MPEN);
    MoveTo(H,framewidth ,HEIGHT-framewidth);
		LineTo(H,corner - 1,HEIGHT-framewidth );

			{lower WIDTH}
    selectobject(h,MPEN);
		MoveTo(H,Width-framewidth ,HEIGHT-framewidth );
		LineTo(H,Width-framewidth ,HEIGHT- corner -1);
		MoveTo(H,Width-framewidth ,HEIGHT-framewidth );
		LineTo(H,Width- corner - 1,HEIGHT-framewidth );

		{Upper WIDTH}
    selectobject(h,getstockobject(BLACK_PEN));
		MoveTo(H,Width-corner - 1,framewidth );
		LineTo(H,Width-framewidth ,framewidth );
    selectobject(h,MPEN);
		MoveTo(H,Width-framewidth ,framewidth );
		LineTo(H,Width-framewidth ,corner -1);


	{***************************************************}
		{cleanup corner pixels}
    selectobject(h,getstockobject(BLACK_PEN));

		{Lower Left}
		Moveto(H,width,0);
		Lineto(h,width,HEIGHT);
		Moveto(H,width-1,corner);
		Lineto(h,width-1,HEIGHT-corner);

    moveto(h,width - framewidth -1,corner);
    Lineto(h,width -1,corner);

		Moveto(H,width -1,0);
		Lineto(h,width -1,height);


    ReleaseDC(Handle, h);
    deleteobject(mpen);
    deleteobject(hbrCap);
end;

procedure TMotifForm.WndProc(var Message : TMessage);
begin
  with Message do begin
    case msg of
    WM_NCPAINT,
    WM_NCACTIVATE:
      begin
        inherited WndProc(Message);
        if HasCaption and not IsIconic(Handle) then begin
          if msg = WM_NCPAINT then
            fActive := (Handle = GetActiveWindow)
          else
            fActive := (wparam <> 0);
        Drawframe;
        DrawCaption;
        end;
      end;
    else
      inherited WndProc(Message);
    end; { case msg of }
  end; { with Message do }
end;

procedure TMotifForm.WMNCCreate(var Message : TWMNCCreate);
var
  dwStyle : longint;
begin
  fMenuUp := false;  {System menu not initially showing}
  TitleBarSize := (GetSystemMetrics(SM_CYCAPTION)) ;
  dwStyle := GetWindowLong(Handle, GWL_STYLE);
  if (dwStyle and WS_DLGFRAME) = WS_DLGFRAME then
    dwStyle := dwStyle and not longint(WS_DLGFRAME);
  SetWindowLong(Handle, GWL_STYLE, dwStyle);
  fSysMenu :=TestWinStyle(WS_SYSMENU);
  fMin:= TestWinStyle(WS_MINIMIZEBOX);
  fMax := TestWinStyle(WS_MAXIMIZEBOX);
  PUSHED := FALSE;

  inherited;  {Call default processing.}
end;

procedure TMotifForm.WMNCCalcSize(var Message : TWMNCCalcSize);
begin
  inherited;  {Call default processing.}
  if HasCaption and not IsIconic(Handle) then
    Inc(Message.CalcSize_Params^.rgrc[0].top, TitleBarSize);
end;

procedure TMotifForm.WMNCHitTest(var Message : TWMNCHitTest);
var
  rcCap  : TRect;
  rcMenu : TRect;
  rcMin  : TRect;
  rcMax  : TRect;
begin
  inherited;  {Call default processing.}
  if (Message.Result = HTNOWHERE) and HasCaption and not IsIconic(Handle) then begin
    GetTitleBarRect(rcCap);
    if PtInRect(rcCap, Message.Pos) then begin
      Message.Result := HTCAPTION;
      GetControlBoxRect(rcMenu);
      GetMinButtonRect(rcMin);
      GetMaxButtonRect(rcMax);
      if PtInRect(rcMenu, Message.Pos) then
        Message.Result := HTSYSMENU
      else if PtInRect(rcMin, Message.Pos) then
        Message.Result := HTMINBUTTON
      else if PtInRect(rcMax, Message.Pos) then
        Message.Result := HTMAXBUTTON;
    end;
  end;
  if Message.Result <> HTSYSMENU then
    fMenuUp := false;  {Indicate the system menu is not showing}
end;

procedure TMotifForm.WMNCLButtonDblClk(var Message : TWMNCLButtonDblClk);
begin
  if (Message.HitTest = HTSYSMENU) and HasCaption and not IsIconic(Handle) then
    SendMessage(Handle, WM_CLOSE, 0, 0)
  else
    inherited;  {Call default processing.}
end;


procedure TMotifForm.WMNCLButtonDown(var Message : TWMNCLButtonDown);
var
  rc : TRect;
  pt : TPoint;
begin
  if HasCaption and not IsIconic(Handle) then begin
    case Message.HitTest of
{    HTCAPTION:BEGIN
                drawcaptionpush(pushed);
                inherited;
              END;}
    HTSYSMENU:
      if not fMenuUp and DoMenu then
        fMenuUp := true
      else
        fMenuUp := false;
    HTMINBUTTON:
      begin
        pt := Point(Message.XCursor, Message.YCursor);
        GetMinButtonRect(rc);
        if DepressMinMaxButton(Message.HitTest, rc) then
          SendMessage(Handle, WM_SYSCOMMAND, SC_MINIMIZE, longint(pt));
      end;
    HTMAXBUTTON:
      begin
        pt := Point(Message.XCursor, Message.YCursor);
        GetMaxButtonRect(rc);
        if DepressMinMaxButton(Message.HitTest, rc) then begin
          if IsZoomed(Handle) then
            SendMessage(Handle, WM_SYSCOMMAND, SC_RESTORE, longint(pt))
          else
            SendMessage(Handle, WM_SYSCOMMAND, SC_MAXIMIZE, longint(pt));
        end;
      end;
    else
      inherited;  {Call default processing.}
    end;
  end else
    inherited;  {Call default processing.}
end;

procedure TMotifForm.WMSysChar(var Message : TWMSysChar);
begin
  if HasCaption and (Message.CharCode = VK_SPACE) then
    DoMenu
  else
    inherited;  {Call default processing.}
end;

procedure TMotifForm.WMCommand(var Message : TMessage);
begin
  if Message.wParam >= $F000 then
    PostMessage(Handle, WM_SYSCOMMAND, Message.wParam, Message.lParam);
  inherited;  {Call default processing.}
end;

procedure TMotifForm.WMKeyDown(var Message : TWMKeyDown);
var
  dwStyle : longint;
begin
  dwStyle := GetWindowLong(Handle, GWL_STYLE);
  SetWIndowLong(Handle, GWL_STYLE, dwStyle and not longint(WS_SYSMENU));
  inherited;  {Call default processing.}
  SetWindowLong(Handle, GWL_STYLE, dwStyle);
end;

procedure TMotifForm.WMKeyUp(var Message : TWMKeyUp);
var
  dwStyle : longint;
begin
  dwStyle := GetWindowLong(Handle, GWL_STYLE);
  SetWIndowLong(Handle, GWL_STYLE, dwStyle and not longint(WS_SYSMENU));
  inherited;  {Call default processing.}
  SetWindowLong(Handle, GWL_STYLE, dwStyle);
end;

procedure TMotifForm.WMSysKeyDown(var Message : TWMSysKeyDown);
var
  dwStyle : longint;
begin
  dwStyle := GetWindowLong(Handle, GWL_STYLE);
  SetWIndowLong(Handle, GWL_STYLE, dwStyle and not longint(WS_SYSMENU));
  inherited;  {Call default processing.}
  SetWindowLong(Handle, GWL_STYLE, dwStyle);
end;

procedure TMotifForm.WMSysKeyUp(var Message : TWMSysKeyUp);
var
  dwStyle : longint;
begin
  dwStyle := GetWindowLong(Handle, GWL_STYLE);
  SetWIndowLong(Handle, GWL_STYLE, dwStyle and not longint(WS_SYSMENU));
  inherited;  {Call default processing.}
  SetWindowLong(Handle, GWL_STYLE, dwStyle);
end;

procedure TMotifForm.WMGetMinMaxInfo(var Message : TWMGetMinMaxInfo);
var
  nX     : integer;
  cy     : integer;
  rcBox  : TRect;
  rcMin  : TRect;
  rcMax  : TRect;
begin
  if HasCaption and TestWinStyle(WS_THICKFRAME) then begin
    cy := GetSystemMetrics(SM_CYFRAME);
    {The following functions return empty rects. if box/button doesn't exist}
    GetControlBoxRect(rcBox);
    GetMinButtonRect(rcMin);
    GetMaxButtonRect(rcMax);
    nX := (rcBox.right - rcBox.left) +
          (rcMin.right - rcMin.left) +
          (rcMax.right - rcMax.left);
    with Message.MinMaxInfo^.ptMinTrackSize do begin
      x := nX + 2 * TitleBarSize;
      y := TitleBarSize + 2 * cy - 1;
    end;
  end;
end;

Constructor TMotifForm.create(owner: tcomponent);
begin
{} inherited create(owner);
  FRAMEWIDTH := ((WIDTH - CLIENTWIDTH) DIV 2);
  corner := getsystemmetrics(SM_CYSIZE) + framewidth;

end;

end.
